package machine;

import automaton.DeterministicAutomaton;
import automaton.NotDeterministicInitialStateException;
import automaton.NotDeterministiTransitionException;
import automaton.State;
import automaton.Transition;
import automaton.UnknownInitialStateException;

public class FiniteStateMachine<T> extends DeterministicAutomaton<T> {

	public FiniteStateMachine(TransitionWithAction<T>[] transitions)
			throws NotDeterministiTransitionException,
			NotDeterministicInitialStateException, UnknownInitialStateException {
		super(transitions);
	}

	protected State changeCurrentState(Transition<T> t) {
		return ((TransitionWithAction<T>) t).cross();
	}
}
