package machine;

import automaton.State;
import automaton.Transition;

public class TransitionWithAction<T> implements Transition<T> {

	private final Transition<? extends T> transition;
	private final Action<? super T> action;

	public TransitionWithAction(Transition<? extends T> t, Action<? super T> a) {
		this.transition = t;
		this.action = a;
	}

	public T label() {
		return transition.label();
	}

	public State source() {
		return transition.source();
	}

	public State target() {
		return transition.target();
	}

	public State cross() {
		action.execute(transition.label());
		return transition.target();
	}

}
